generic
    type user_type is private;
    with function "+"(L, R:user_type) return user_type is <>;

package Matrix_Operations is
    MATRIX_ADD_ERROR : exception;
    type matrix is array(positive range <>, psotive range <>) of user_type;
    function "+" (M1, M2 : matrix) return matrix);
end Matrix_Operations;

package body Matrix_Operations is
    function "+" (M1, M2 : matrix) return matrix is
         RESULT : matrix(M1'range(1), M2'range(2));
    begin
         if M1'length(1) /= M2'length(1) or
            M1'length(2) /= M2'length(2)
         then
            raise MATRIX_ADD_ERROR;
         end if;
         for L in M1'range(1) loop
            for R in M2'range(2) loop
               RESULT(L,R) := M1(L,R) + M2(L,R);
            end loop;
         end loop;
         return RESULT;
    end "+";
end Matrix_Operations;
